/*

reinhard@finalmedia.de
26.02.2014

BSD Lizenz

example-usage:  zcat finalmedia.txt.gz | ascii2fbdev -w 1024 -h 768 -d 32 > /dev/fb0

*/

#include <stdio.h>

#define MAXCOLS		4096

char c;
int count=0,i=0,total=0,d=0,rendered=0;
int fbcols,fbrows,fbbpp,b;
static char *usage = "usage: ./ascii2fbdev -w width -h height -d bitdepth [-f frames] > /dev/fb0\n";


int main(int argc, char *argv[])
{
	for (i = 1; i < argc; i++) {
		switch (argv[i][0] == '-' ? argv[i][1] : '?') {
		case 'w':
			fbcols = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'h':
			fbrows = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]);
			break;
		case 'd':
			fbbpp = atoi(argv[i][2] ? argv[i] + 2 : argv[++i]) / 8;
			break;
		default:
			fprintf(stderr, "%s", usage);
			return 0;
		}
	}



	if (fbcols <= 0 || fbcols > MAXCOLS || fbrows <= 0 || fbbpp <= 0) {
		fprintf(stderr, "%s", usage);
		return 1;
	}



	while (total<(fbcols*fbrows))
	{

	c=getc(stdin);

	count++;

	/* only render if width is not too big */
	if (count<=fbcols) {

		if( c == '1' ) {
		for (d=0;d<fbbpp;d++) { putc(255,stdout); }
		};

		if( c == '0' ) {
		for (d=0;d<fbbpp;d++) { putc(0,stdout); }
		};

	total++;
	}

	if( c == '\n' ) {
	for(i=0;i<=(fbcols-count);i++) {
	for (d=0;d<fbbpp;d++) { putc(0,stdout); }
	}
	count=0;
	fflush(stdout);

	};


	if (c==EOF) return 0;


	}

return 0;


}



